function obj=randsym(N,d,varargin)
% FUNCTION fc_amat.random.randsym
% -- randnsym(N,d) 
%      Returns a N-by-d-by-d amat object whose matrices are symmetric with 
%      random elements uniformly distributed on the open interval (0, 1).
%
%      Optional key/value pair pairs arguments are available with keys:
%        - 'class', value can be 'single' or 'double' (default).
%
%      See also: fc_amat.random.randnher,
%                class amat
%
  p = inputParser; 
  p.addParamValue('class','double',@(x) ismember(lower(x),{'single','double'})); 
  p.parse(varargin{:});
  classname=p.Results.class;
  obj=amat(N,d,d,classname);
  for i=1:d
    obj(i,i)=rand(N,1,classname);
    for j=i+1:d
      obj(i,j)=rand(N,1,classname);
      obj(j,i)=obj(i,j);
    end
  end
end
