function plotquiver2D(distribute)
  if nargin==0, distribute=true;end
  close all % :start:
  v={@(x,y) y.*sqrt(x.^2+y.^2),@(x,y) -x.*sqrt(x.^2+y.^2)};
  vv={@(x,y) x/5,@(x,y) y/5};
  [q2,me2,toGlobal2]=fc_meshtools.simplicial.getMesh2D(2); % Select small mesh
  V2=fc_meshtools.eval(v,q2);
  u2=sqrt(V2{1}.^2+V2{2}.^2);
  [q1,me1,toGlobal1]=fc_meshtools.simplicial.getMesh2D(1);
  V1=fc_meshtools.eval(v,q1);
  VV1=fc_meshtools.eval(vv,q1);
  u1=sqrt(V1{1}.^2+V1{2}.^2);
  figure(1)
  fc_graphics4mesh.plotmesh(q2,me2,'color','LightGray')
  hold on
  fc_graphics4mesh.plotquiver(q2,me2,V2, 'color','Olive','freq',4,'scale',0.1)
  axis image;axis off
  figure(2)
  fc_graphics4mesh.plotmesh(q2,me2,'color','LightGray')
  hold on
  fc_graphics4mesh.plotquiver(q1,me1,V1,'LineWidth',2)
  axis image;axis off 
  figure(3)
  colormap('jet')
  fc_graphics4mesh.plotmesh(q2,me2,'color','LightGray')
  hold on
  fc_graphics4mesh.plotquiver(q2,me2,V2,'colordata',u2)
  axis image;axis off
  colorbar
  figure(4)
  colormap('jet')
  fc_graphics4mesh.plotmesh(q2,me2,'color','LightGray')
  hold on
  fc_graphics4mesh.plotquiver(q1,me1,VV1,'LineWidth',2,'colordata',@(x,y) sin(x+y))
  axis image;axis off
  colorbar  % :end:
  if distribute,fc_tools.graphics.monitors.autoGrid();end
end
