function plotquiver3D(distribute)
  if nargin==0, distribute=true;end
  close all % :start:
  small=false;
  v={@(x,y,z) cos(x+z).*sin(y),@(x,y,z) sin(x).*cos(z+y),@(x,y,z) sin(z).*cos(x+y)};
  [q3,me3,toGlobal3]=fc_meshtools.simplicial.getMesh3D(3,small);
  V3=fc_meshtools.eval(v,q3);
  fu3=@(x,y,z) y;
  u3=fc_meshtools.eval(fu3,q3);
  [q2,me2,toGlobal2]=fc_meshtools.simplicial.getMesh3D(2,small);
  V2=fc_meshtools.eval(v,q2);
  u2=sqrt(V2{1}.^2+V2{2}.^2+V2{3}.^2);
  [q1,me1,toGlobal1]=fc_meshtools.simplicial.getMesh3D(1,small);
  V1=fc_meshtools.eval(v,q1);
  u1=sqrt(V1{1}.^2+V1{2}.^2+V1{3}.^2); 
  figure(1)
  fc_graphics4mesh.plotmesh(q1,me1,'color','k')
  hold on
  fc_graphics4mesh.plotquiver(q3,me3,V3,'freq',2)
  axis image;axis off
  figure(2)
  fc_graphics4mesh.plotmesh(q1,me1,'color','k')
  hold on
  fc_graphics4mesh.plotquiver(q2,me2,V2)
  axis image;axis off
  figure(3)
  colormap('jet')
  fc_graphics4mesh.plotmesh(q1,me1,'color','k')
  hold on;axis image;axis off
  fc_graphics4mesh.plotquiver(q3,me3,V3,'colordata',u3, 'freq',2)
  colorbar
  figure(4)
  set(figure(4),'Visible','off')
  colormap('jet')
  fc_graphics4mesh.plotmesh(q1,me1,'color','k')
  hold on;axis image;axis off
  fc_graphics4mesh.plotquiver(q2,me2,V2, 'colordata',u2)%,'scale',1)
  colorbar
  set(figure(4),'Visible','on') % :end:
  if distribute,fc_tools.graphics.monitors.autoGrid();end
end
