%% 2D Hyperrectangle [-1,1]x[0,1] - 3-order simplicial mesh
%

type='simplex';order=3;

fprintf('--------------- fc_hypermesh.demos.demo13\n')
fprintf('2D Hyperrectangle [-1,1]x[0,1] - mesh with %d-order %s elements\n',order,type);
fprintf('---------------\n')

Oh=fc_hypermesh.OrthMesh(2,10,'box',[-1,1;0,1],'type',type,'order',order);

close all
fc_tools.graphics.monitors.onGrid(2,3,'figures',1:5,'covers',0.9)
% plot the main mesh
figure(1)
Oh.plotmesh()
legend('show')
% plot the 1-face meshes
figure(2)
Oh.plotmesh('color',[0.8,0.8,0.8])
hold on
Oh.plotmesh('m',1,'Linewidth',2,'legend',true)
axis off
% plot the 0-face meshes
figure(3)
Oh.plotmesh('m',1,'color','k')
hold on
Oh.plotmesh('m',0,'legend',true)
axis off

figure(4)
Oh.plotmesh()
hold on
Oh.plotnodes()
% plot the 1-face meshes
figure(5)
Oh.plotmesh('color',[0.8,0.8,0.8])
hold on
Oh.plotmesh('m',1,'Linewidth',2)
Oh.plotnodes('m',1)
axis off
