function Elements=read_Elements(fid,varargin)
  p = inputParser;
  p.addParamValue('verbose',false,@islogical);
  p.parse(varargin{:});
  verbose=p.Results.verbose;
  flag=fc_oogmsh.msh.find_section(fid,'$Elements',varargin{:});
  R=fscanf(fid,'%d',4);
  numEntityBlocks=R(1);numElements=R(2);minElementTag=R(3);maxElementTag=R(4);
  EntityBlocks=struct('entityDim',[],'entityTag',[],'elementType',[],'elementDesc',[],'elementTags',[],'nodeTags',[]); % NodeTags is connectivity array
  EntityBlocks=repmat(EntityBlocks,1,numEntityBlocks);
  elm_type_list=fc_oogmsh.gmsh.elm_type_list();
  ElementTypes=zeros(1,numEntityBlocks);
  for i=1:numEntityBlocks
    %text = fgetl ( fid );
    R=fscanf(fid,'%d',4);
    EntityBlocks(i).entityDim=R(1);EntityBlocks(i).entityTag=R(2);
    EntityBlocks(i).elementType=R(3);EntityBlocks(i).numElementsBlock=R(4);
    EntityBlocks(i).elementDesc=elm_type_list{R(3)};
    ElementTypes(i)=R(3);
    nb_nodes_by_elt=EntityBlocks(i).elementDesc.nb_nodes;
    N=fscanf(fid,'%d',(nb_nodes_by_elt+1)*R(4)); % reading by line elementTag nodeTag ... nodeTag
    N=reshape(N,nb_nodes_by_elt+1,R(4));
    EntityBlocks(i).elementTags=N(1,:);
    EntityBlocks(i).nodeTags= N(2:end,:);
  end
 
  text = fscanf(fid,'%s',1);
  if ( text == -1 ) | ~strcmp(strtok(text),'$EndElements') 
    error('Trouble when reading file in section $Elements %s',text)
  else
    if verbose,fprintf('Reading $Elements section seem OK\n');end
  end
  Elements=struct('numEntityBlocks',numEntityBlocks, 'numElements',numElements, ...
                  'minElementTag',minElementTag, 'maxElementTag',maxElementTag, ...
                  'EntityBlocks',EntityBlocks,'ElementTypes',ElementTypes);
end
