function varargout=feval3D01(varargin)
  % Th=fc_simesh.demos.feval3D01('geofile','cylinder3holes','N',10,'verbose',2,'MshFileVersion','4.1','force',true);
  fprintf('************************************\n')
  fprintf('  Running %s function\n',mfilename())
  fprintf('************************************\n')
  [Th,verbose]=fc_siMesh.demos.setMesh3D(varargin{:});
  
  g1=@(x,y,z) cos(x).*sin(y).*exp(z);
  g2=@(q) cos(q(1,:)).*sin(q(2,:)).*exp(q(3,:));

  if verbose,fprintf('*** Computing functions on mesh\n');end
  z1=Th.feval(g1);
  z2=Th.feval(g2);
  z3=Th.feval(@g3);
  z4=Th.feval(@g4);
  
  if verbose,fprintf('*** Check results\n');end
  res=0;
  res=res+ ~( (size(z1,1)==Th.nq) && (size(z2,1)==Th.nq) && (size(z3,1)==Th.nq) && (size(z4,1)==Th.nq) );
  if verbose, if (res==1),    fprintf('  Test 0: failed with dimensions\n');else fprintf('  Test 0: OK\n');end;end
  E=max(abs(z2-z1));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 1: failed with E=%g\n',E);else fprintf('  Test 1: OK\n');end;end
  E=max(abs(z3-z1));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 2: failed with E=%g\n',E);else fprintf('  Test 2: OK\n');end;end
  E=max(abs(z4-z1));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 3: failed with E=%g\n',E);else fprintf('  Test 3: OK\n');end;end
  if res>0,error('demo % failed',mfilename()');end
  if nargout==1,varargout{1}=Th;end
end

function w=g3(x,y,z)
  w=cos(x).*sin(y).*exp(z);
end

function w=g4(q)
  w=cos(q(1,:)).*sin(q(2,:)).*exp(q(3,:));
end
  
