function slice(varargin)
  close all % :start:
  meshfile=fc_oogmsh.gmsh.buildmesh3d('cylinder3holes',10,varargin{:});
  Th=fc_simesh.siMesh(meshfile);

  u=@(x,y,z) cos(2*x-y-z).*sin(x-2*y+z);
  U=Th.eval(u);
  
  figure(1)
  P=fc_tools.graphics.PlaneCoefs([0 0 1],[1 -1 1]);
  Th.slice(U,P)
  hold on
  Th.plotmesh('d',1,'color','k')
  axis equal
  view(-11,15) 
  
  P=[fc_tools.graphics.PlaneCoefs([0 0 1/2],[1 0 0]); ...
     fc_tools.graphics.PlaneCoefs([0 0 1/2],[0 1 0]); ...
     fc_tools.graphics.PlaneCoefs([0 0 1],[1 -1 1])];
  figure(2)
  Th.slice(U,P)
  hold on
  Th.plotmesh('d',1,'color','k')
  axis equal
  view(-11,15) % :end:
end
