fc_tools.utils.cleaning()
N=10;
options={'perm',@(A) colamd(A)};
[bvp,info]=fc_vfemp1.examples.setBVPCondenser2D01(N,2);
fc_vfemp1.examples.print_info(info)

fprintf('*** Solving %s\n',info.name)
[U,SolveInfo]=bvp.solve('time',true,options{:});
fprintf('    -> ndof (number of degrees of freedom) = %d\n',length(U));
fc_vfemp1.examples.print_info(SolveInfo)

if fc_tools.utils.is_fcPackage('siplt')
  fprintf('*** Graphics with fc_siplt package\n');
  tstart=tic();
  Th=bvp.Th;
  figure(1)
  Th.plotmesh('inlegend',true)
  legend('show')
  axis equal;axis off
  title('Condenser2D[01], mesh')
  
  figure(2)
  Th.plotmesh('color','LightGray')
  hold on
  Th.plotmesh('d',1,'inlegend',true)
  legend('show')
  axis equal;axis off
  title('Condenser2D[01], boundary meshes')

  figure(3)
  Th.plot(U)
  axis off,axis image
  colorbar()
  shading interp
  title('Condenser2D[01], P1-FEM solution')
 
  figure(4)
  Th.plotmesh('d',1,'color','k')
  hold on
  [~,~,cax]=Th.plotiso(U,'niso',20,'isocolorbar',true,'format','%.3f');
  %set(cax,options.colorbar{:});
  axis off,axis image
  title('Condenser2D[01], P1-FEM solution - isolines')
  tcpu=toc(tstart);
  fprintf('    -> Done it in %.3f(s)\n',tcpu)

  fc_tools.graphics.monitors.autoGrid('covers',0.9)
end
