classdef Hoperator < handle
  properties %(SetAccess = protected)
    dim = 0; % space dimension
    d=0;
    m   = 0;
    H = {};
    sym = false;
    name= '';
  end

  methods
    function self=Hoperator(dim,d,m)
      if nargin==0, return;end
      self.dim=dim;self.m=m;self.d=d;
      self.H=cell(m,m);
    end
    
    function f=apply(self,Th,u)
    % FC: to improve
      bvp=fc_vfemp1.BVP(Th,fc_vfemp1.PDE(self));
      [A,b]=bvp.Assembly('local',true);
      Hop=fc_vfemp1.Hoperator(self.dim,self.d,self.m);
      Lop=fc_vfemp1.Loperator(self.dim,self.d,[],[],[],1);
      for i=1:self.m, Hop.H{i,i}=Lop;end
      bvp=fc_vfemp1.BVP(Th,fc_vfemp1.PDE(Hop));
      [M,b]=bvp.Assembly('local',true);
      U=[];
      for i=1:self.m,U=[U;u{i}];end
      f=M\(A*U);
      f=bvp.splitsol(f);
    end
    
    function self=set(self,i,j,Lop)
      %assert( strcmp(class(Lop),'Loperator') );
      assert( fc_vfemp1.is_Loperator(Lop) );
      assert( Lop.dim == self.dim);
      assert(sum(~ismember(i,1:self.m))==0);
      assert(sum(~ismember(j,1:self.m))==0);
      for l=1:length(i)
        self.H{i(l),j(l)}=Lop;
      end
    end
    
    function self=zeros(self,dim,m) % To suppress
      assert( isscalar(dim) && isscalar(m) );
      assert( dim>0 && m>0 );
      self.dim=dim;
      self.m=m;
      self.H=cell(m,m);
    end
    
  end % methods
end % classdef
